####################################################################
#
#    This file was generated using Parse::Yapp version 1.05.
#
#        Don't edit this file, use source file instead.
#
#             ANY CHANGE MADE HERE WILL BE LOST !
#
####################################################################
package TAG::LP::Parser;
use vars qw ( @ISA );
use strict;

@ISA= qw ( Parse::Yapp::Driver );
#Included Parse/Yapp/Driver.pm file----------------------------------------
{
#
# Module Parse::Yapp::Driver
#
# This module is part of the Parse::Yapp package available on your
# nearest CPAN
#
# Any use of this module in a standalone parser make the included
# text under the same copyright as the Parse::Yapp module itself.
#
# This notice should remain unchanged.
#
# (c) Copyright 1998-2001 Francois Desarmenien, all rights reserved.
# (see the pod text in Parse::Yapp module for use and distribution rights)
#

package Parse::Yapp::Driver;

require 5.004;

use strict;

use vars qw ( $VERSION $COMPATIBLE $FILENAME );

$VERSION = '1.05';
$COMPATIBLE = '0.07';
$FILENAME=__FILE__;

use Carp;

#Known parameters, all starting with YY (leading YY will be discarded)
my(%params)=(YYLEX => 'CODE', 'YYERROR' => 'CODE', YYVERSION => '',
			 YYRULES => 'ARRAY', YYSTATES => 'ARRAY', YYDEBUG => '');
#Mandatory parameters
my(@params)=('LEX','RULES','STATES');

sub new {
    my($class)=shift;
	my($errst,$nberr,$token,$value,$check,$dotpos);
    my($self)={ ERROR => \&_Error,
				ERRST => \$errst,
                NBERR => \$nberr,
				TOKEN => \$token,
				VALUE => \$value,
				DOTPOS => \$dotpos,
				STACK => [],
				DEBUG => 0,
				CHECK => \$check };

	_CheckParams( [], \%params, \@_, $self );

		exists($$self{VERSION})
	and	$$self{VERSION} < $COMPATIBLE
	and	croak "Yapp driver version $VERSION ".
			  "incompatible with version $$self{VERSION}:\n".
			  "Please recompile parser module.";

        ref($class)
    and $class=ref($class);

    bless($self,$class);
}

sub YYParse {
    my($self)=shift;
    my($retval);

	_CheckParams( \@params, \%params, \@_, $self );

	if($$self{DEBUG}) {
		_DBLoad();
		$retval = eval '$self->_DBParse()';#Do not create stab entry on compile
        $@ and die $@;
	}
	else {
		$retval = $self->_Parse();
	}
    $retval
}

sub YYData {
	my($self)=shift;

		exists($$self{USER})
	or	$$self{USER}={};

	$$self{USER};
	
}

sub YYErrok {
	my($self)=shift;

	${$$self{ERRST}}=0;
    undef;
}

sub YYNberr {
	my($self)=shift;

	${$$self{NBERR}};
}

sub YYRecovering {
	my($self)=shift;

	${$$self{ERRST}} != 0;
}

sub YYAbort {
	my($self)=shift;

	${$$self{CHECK}}='ABORT';
    undef;
}

sub YYAccept {
	my($self)=shift;

	${$$self{CHECK}}='ACCEPT';
    undef;
}

sub YYError {
	my($self)=shift;

	${$$self{CHECK}}='ERROR';
    undef;
}

sub YYSemval {
	my($self)=shift;
	my($index)= $_[0] - ${$$self{DOTPOS}} - 1;

		$index < 0
	and	-$index <= @{$$self{STACK}}
	and	return $$self{STACK}[$index][1];

	undef;	#Invalid index
}

sub YYCurtok {
	my($self)=shift;

        @_
    and ${$$self{TOKEN}}=$_[0];
    ${$$self{TOKEN}};
}

sub YYCurval {
	my($self)=shift;

        @_
    and ${$$self{VALUE}}=$_[0];
    ${$$self{VALUE}};
}

sub YYExpect {
    my($self)=shift;

    keys %{$self->{STATES}[$self->{STACK}[-1][0]]{ACTIONS}}
}

sub YYLexer {
    my($self)=shift;

	$$self{LEX};
}


#################
# Private stuff #
#################


sub _CheckParams {
	my($mandatory,$checklist,$inarray,$outhash)=@_;
	my($prm,$value);
	my($prmlst)={};

	while(($prm,$value)=splice(@$inarray,0,2)) {
        $prm=uc($prm);
			exists($$checklist{$prm})
		or	croak("Unknow parameter '$prm'");
			ref($value) eq $$checklist{$prm}
		or	croak("Invalid value for parameter '$prm'");
        $prm=unpack('@2A*',$prm);
		$$outhash{$prm}=$value;
	}
	for (@$mandatory) {
			exists($$outhash{$_})
		or	croak("Missing mandatory parameter '".lc($_)."'");
	}
}

sub _Error {
	print "Parse error.\n";
}

sub _DBLoad {
	{
		no strict 'refs';

			exists(${__PACKAGE__.'::'}{_DBParse})#Already loaded ?
		and	return;
	}
	my($fname)=__FILE__;
	my(@drv);
	open(DRV,"<$fname") or die "Report this as a BUG: Cannot open $fname";
	while(<DRV>) {
                	/^\s*sub\s+_Parse\s*{\s*$/ .. /^\s*}\s*#\s*_Parse\s*$/
        	and     do {
                	s/^#DBG>//;
                	push(@drv,$_);
        	}
	}
	close(DRV);

	$drv[0]=~s/_P/_DBP/;
	eval join('',@drv);
}

#Note that for loading debugging version of the driver,
#this file will be parsed from 'sub _Parse' up to '}#_Parse' inclusive.
#So, DO NOT remove comment at end of sub !!!
sub _Parse {
    my($self)=shift;

	my($rules,$states,$lex,$error)
     = @$self{ 'RULES', 'STATES', 'LEX', 'ERROR' };
	my($errstatus,$nberror,$token,$value,$stack,$check,$dotpos)
     = @$self{ 'ERRST', 'NBERR', 'TOKEN', 'VALUE', 'STACK', 'CHECK', 'DOTPOS' };

#DBG>	my($debug)=$$self{DEBUG};
#DBG>	my($dbgerror)=0;

#DBG>	my($ShowCurToken) = sub {
#DBG>		my($tok)='>';
#DBG>		for (split('',$$token)) {
#DBG>			$tok.=		(ord($_) < 32 or ord($_) > 126)
#DBG>					?	sprintf('<%02X>',ord($_))
#DBG>					:	$_;
#DBG>		}
#DBG>		$tok.='<';
#DBG>	};

	$$errstatus=0;
	$$nberror=0;
	($$token,$$value)=(undef,undef);
	@$stack=( [ 0, undef ] );
	$$check='';

    while(1) {
        my($actions,$act,$stateno);

        $stateno=$$stack[-1][0];
        $actions=$$states[$stateno];

#DBG>	print STDERR ('-' x 40),"\n";
#DBG>		$debug & 0x2
#DBG>	and	print STDERR "In state $stateno:\n";
#DBG>		$debug & 0x08
#DBG>	and	print STDERR "Stack:[".
#DBG>					 join(',',map { $$_[0] } @$stack).
#DBG>					 "]\n";


        if  (exists($$actions{ACTIONS})) {

				defined($$token)
            or	do {
				($$token,$$value)=&$lex($self);
#DBG>				$debug & 0x01
#DBG>			and	print STDERR "Need token. Got ".&$ShowCurToken."\n";
			};

            $act=   exists($$actions{ACTIONS}{$$token})
                    ?   $$actions{ACTIONS}{$$token}
                    :   exists($$actions{DEFAULT})
                        ?   $$actions{DEFAULT}
                        :   undef;
        }
        else {
            $act=$$actions{DEFAULT};
#DBG>			$debug & 0x01
#DBG>		and	print STDERR "Don't need token.\n";
        }

            defined($act)
        and do {

                $act > 0
            and do {        #shift

#DBG>				$debug & 0x04
#DBG>			and	print STDERR "Shift and go to state $act.\n";

					$$errstatus
				and	do {
					--$$errstatus;

#DBG>					$debug & 0x10
#DBG>				and	$dbgerror
#DBG>				and	$$errstatus == 0
#DBG>				and	do {
#DBG>					print STDERR "**End of Error recovery.\n";
#DBG>					$dbgerror=0;
#DBG>				};
				};


                push(@$stack,[ $act, $$value ]);

					$$token ne ''	#Don't eat the eof
				and	$$token=$$value=undef;
                next;
            };

            #reduce
            my($lhs,$len,$code,@sempar,$semval);
            ($lhs,$len,$code)=@{$$rules[-$act]};

#DBG>			$debug & 0x04
#DBG>		and	$act
#DBG>		and	print STDERR "Reduce using rule ".-$act." ($lhs,$len): ";

                $act
            or  $self->YYAccept();

            $$dotpos=$len;

                unpack('A1',$lhs) eq '@'    #In line rule
            and do {
                    $lhs =~ /^\@[0-9]+\-([0-9]+)$/
                or  die "In line rule name '$lhs' ill formed: ".
                        "report it as a BUG.\n";
                $$dotpos = $1;
            };

            @sempar =       $$dotpos
                        ?   map { $$_[1] } @$stack[ -$$dotpos .. -1 ]
                        :   ();

            $semval = $code ? &$code( $self, @sempar )
                            : @sempar ? $sempar[0] : undef;

            splice(@$stack,-$len,$len);

                $$check eq 'ACCEPT'
            and do {

#DBG>			$debug & 0x04
#DBG>		and	print STDERR "Accept.\n";

				return($semval);
			};

                $$check eq 'ABORT'
            and	do {

#DBG>			$debug & 0x04
#DBG>		and	print STDERR "Abort.\n";

				return(undef);

			};

#DBG>			$debug & 0x04
#DBG>		and	print STDERR "Back to state $$stack[-1][0], then ";

                $$check eq 'ERROR'
            or  do {
#DBG>				$debug & 0x04
#DBG>			and	print STDERR 
#DBG>				    "go to state $$states[$$stack[-1][0]]{GOTOS}{$lhs}.\n";

#DBG>				$debug & 0x10
#DBG>			and	$dbgerror
#DBG>			and	$$errstatus == 0
#DBG>			and	do {
#DBG>				print STDERR "**End of Error recovery.\n";
#DBG>				$dbgerror=0;
#DBG>			};

			    push(@$stack,
                     [ $$states[$$stack[-1][0]]{GOTOS}{$lhs}, $semval ]);
                $$check='';
                next;
            };

#DBG>			$debug & 0x04
#DBG>		and	print STDERR "Forced Error recovery.\n";

            $$check='';

        };

        #Error
            $$errstatus
        or   do {

            $$errstatus = 1;
            &$error($self);
                $$errstatus # if 0, then YYErrok has been called
            or  next;       # so continue parsing

#DBG>			$debug & 0x10
#DBG>		and	do {
#DBG>			print STDERR "**Entering Error recovery.\n";
#DBG>			++$dbgerror;
#DBG>		};

            ++$$nberror;

        };

			$$errstatus == 3	#The next token is not valid: discard it
		and	do {
				$$token eq ''	# End of input: no hope
			and	do {
#DBG>				$debug & 0x10
#DBG>			and	print STDERR "**At eof: aborting.\n";
				return(undef);
			};

#DBG>			$debug & 0x10
#DBG>		and	print STDERR "**Dicard invalid token ".&$ShowCurToken.".\n";

			$$token=$$value=undef;
		};

        $$errstatus=3;

		while(	  @$stack
			  and (		not exists($$states[$$stack[-1][0]]{ACTIONS})
			        or  not exists($$states[$$stack[-1][0]]{ACTIONS}{error})
					or	$$states[$$stack[-1][0]]{ACTIONS}{error} <= 0)) {

#DBG>			$debug & 0x10
#DBG>		and	print STDERR "**Pop state $$stack[-1][0].\n";

			pop(@$stack);
		}

			@$stack
		or	do {

#DBG>			$debug & 0x10
#DBG>		and	print STDERR "**No state left on stack: aborting.\n";

			return(undef);
		};

		#shift the error token

#DBG>			$debug & 0x10
#DBG>		and	print STDERR "**Shift \$error token and go to state ".
#DBG>						 $$states[$$stack[-1][0]]{ACTIONS}{error}.
#DBG>						 ".\n";

		push(@$stack, [ $$states[$$stack[-1][0]]{ACTIONS}{error}, undef ]);

    }

    #never reached
	croak("Error in driver logic. Please, report it as a BUG");

}#_Parse
#DO NOT remove comment

1;

}
#End of include--------------------------------------------------




sub new {
        my($class)=shift;
        ref($class)
    and $class=ref($class);

    my($self)=$class->SUPER::new( yyversion => '1.05',
                                  yystates =>
[
	{#State 0
		DEFAULT => -2,
		GOTOS => {
			'input' => 1,
			'doc' => 2
		}
	},
	{#State 1
		ACTIONS => {
			"tag_lemma" => 3,
			"tag_lexicon" => 6,
			"tag_tree" => 8
		},
		DEFAULT => -1,
		GOTOS => {
			'lexical' => 4,
			'tree' => 5,
			'clause' => 7,
			'lemma' => 9
		}
	},
	{#State 2
		ACTIONS => {
			'' => 10
		}
	},
	{#State 3
		ACTIONS => {
			"(" => 11
		}
	},
	{#State 4
		ACTIONS => {
			"." => 12
		}
	},
	{#State 5
		ACTIONS => {
			"." => 13
		}
	},
	{#State 6
		ACTIONS => {
			"(" => 14
		}
	},
	{#State 7
		DEFAULT => -3
	},
	{#State 8
		ACTIONS => {
			"{" => 15
		}
	},
	{#State 9
		ACTIONS => {
			"." => 16
		}
	},
	{#State 10
		DEFAULT => 0
	},
	{#State 11
		ACTIONS => {
			'IDENT' => 17
		}
	},
	{#State 12
		DEFAULT => -6
	},
	{#State 13
		DEFAULT => -4
	},
	{#State 14
		ACTIONS => {
			'IDENT' => 18
		}
	},
	{#State 15
		ACTIONS => {
			"name" => 19
		},
		GOTOS => {
			'f_name' => 20
		}
	},
	{#State 16
		DEFAULT => -5
	},
	{#State 17
		ACTIONS => {
			"," => 21
		}
	},
	{#State 18
		ACTIONS => {
			"," => 22
		}
	},
	{#State 19
		ACTIONS => {
			"=>" => 23
		}
	},
	{#State 20
		ACTIONS => {
			"," => 24
		}
	},
	{#State 21
		ACTIONS => {
			'IDENT' => 25
		}
	},
	{#State 22
		ACTIONS => {
			'IDENT' => 26
		}
	},
	{#State 23
		ACTIONS => {
			'IDENT' => 27
		}
	},
	{#State 24
		ACTIONS => {
			"family" => 28
		},
		GOTOS => {
			'f_family' => 29
		}
	},
	{#State 25
		ACTIONS => {
			"," => 30
		}
	},
	{#State 26
		ACTIONS => {
			"," => 31
		}
	},
	{#State 27
		DEFAULT => -8
	},
	{#State 28
		ACTIONS => {
			"=>" => 32
		}
	},
	{#State 29
		ACTIONS => {
			"," => 33
		}
	},
	{#State 30
		ACTIONS => {
			"tag_anchor" => 34,
			"[" => 37
		},
		GOTOS => {
			'anchors' => 35,
			'anchor' => 36
		}
	},
	{#State 31
		ACTIONS => {
			'IDENT' => 38
		}
	},
	{#State 32
		ACTIONS => {
			'IDENT' => 39
		}
	},
	{#State 33
		ACTIONS => {
			"tree" => 40
		},
		GOTOS => {
			'f_tree' => 41
		}
	},
	{#State 34
		ACTIONS => {
			"{" => 42
		}
	},
	{#State 35
		ACTIONS => {
			")" => 43
		}
	},
	{#State 36
		DEFAULT => -51
	},
	{#State 37
		ACTIONS => {
			"tag_anchor" => 34
		},
		GOTOS => {
			'anchor' => 44,
			'anchor_list' => 45
		}
	},
	{#State 38
		ACTIONS => {
			"," => 46
		}
	},
	{#State 39
		DEFAULT => -9
	},
	{#State 40
		ACTIONS => {
			"=>" => 47
		}
	},
	{#State 41
		ACTIONS => {
			"}" => 48
		}
	},
	{#State 42
		ACTIONS => {
			"equations" => 49,
			"name" => 50,
			"coanchors" => 52
		},
		GOTOS => {
			'anchor_feature' => 51,
			'anchor_features' => 53
		}
	},
	{#State 43
		DEFAULT => -50
	},
	{#State 44
		DEFAULT => -53
	},
	{#State 45
		ACTIONS => {
			"," => 54,
			"]" => 55
		}
	},
	{#State 46
		ACTIONS => {
			'VAR' => 56,
			'IDENT' => 57
		},
		GOTOS => {
			'f_arg' => 58,
			'fstruct' => 59
		}
	},
	{#State 47
		ACTIONS => {
			"auxtree" => 60,
			"tree" => 62
		},
		GOTOS => {
			'v_tree' => 61
		}
	},
	{#State 48
		DEFAULT => -7
	},
	{#State 49
		ACTIONS => {
			"=>" => 63
		}
	},
	{#State 50
		ACTIONS => {
			"=>" => 64
		}
	},
	{#State 51
		DEFAULT => -56
	},
	{#State 52
		ACTIONS => {
			"=>" => 65
		}
	},
	{#State 53
		ACTIONS => {
			"}" => 66,
			"," => 67
		}
	},
	{#State 54
		ACTIONS => {
			"tag_anchor" => 34
		},
		GOTOS => {
			'anchor' => 68
		}
	},
	{#State 55
		DEFAULT => -52
	},
	{#State 56
		ACTIONS => {
			"::" => 69
		},
		DEFAULT => -31
	},
	{#State 57
		ACTIONS => {
			"{" => 70
		}
	},
	{#State 58
		ACTIONS => {
			")" => 71
		}
	},
	{#State 59
		DEFAULT => -32
	},
	{#State 60
		ACTIONS => {
			"-" => 73,
			"bot" => 72,
			"+" => 77,
			'IDENT' => 78,
			"*" => 80,
			"id" => 81,
			"top" => 82,
			"[" => 83,
			"<>" => 85
		},
		GOTOS => {
			'info' => 75,
			'mark_node' => 74,
			'e_info' => 76,
			'info_node' => 84,
			'node' => 79
		}
	},
	{#State 61
		DEFAULT => -10
	},
	{#State 62
		ACTIONS => {
			"-" => 73,
			"bot" => 72,
			"+" => 77,
			'IDENT' => 78,
			"*" => 80,
			"id" => 81,
			"top" => 82,
			"[" => 83,
			"<>" => 85
		},
		GOTOS => {
			'info' => 75,
			'mark_node' => 74,
			'e_info' => 76,
			'info_node' => 86,
			'node' => 79
		}
	},
	{#State 63
		ACTIONS => {
			"[" => 87
		}
	},
	{#State 64
		ACTIONS => {
			"[" => 90,
			'IDENT' => 89
		},
		GOTOS => {
			'names' => 88
		}
	},
	{#State 65
		ACTIONS => {
			"[" => 91
		}
	},
	{#State 66
		DEFAULT => -55
	},
	{#State 67
		ACTIONS => {
			"equations" => 49,
			"name" => 50,
			"coanchors" => 52
		},
		GOTOS => {
			'anchor_feature' => 92
		}
	},
	{#State 68
		DEFAULT => -54
	},
	{#State 69
		ACTIONS => {
			'IDENT' => 57
		},
		GOTOS => {
			'fstruct' => 93
		}
	},
	{#State 70
		ACTIONS => {
			'IDENT' => 95
		},
		DEFAULT => -35,
		GOTOS => {
			'fval' => 96,
			'fvals' => 94,
			'nfvals' => 97
		}
	},
	{#State 71
		DEFAULT => -75
	},
	{#State 72
		ACTIONS => {
			"=" => 98
		}
	},
	{#State 73
		ACTIONS => {
			"[" => 83,
			'IDENT' => 78
		},
		GOTOS => {
			'node' => 99
		}
	},
	{#State 74
		DEFAULT => -14
	},
	{#State 75
		ACTIONS => {
			"and" => 100,
			"at" => 101
		}
	},
	{#State 76
		DEFAULT => -26
	},
	{#State 77
		ACTIONS => {
			"[" => 83,
			'IDENT' => 78
		},
		GOTOS => {
			'node' => 102
		}
	},
	{#State 78
		ACTIONS => {
			"(" => 103
		},
		DEFAULT => -20
	},
	{#State 79
		DEFAULT => -19
	},
	{#State 80
		ACTIONS => {
			"[" => 83,
			'IDENT' => 78
		},
		GOTOS => {
			'node' => 104
		}
	},
	{#State 81
		ACTIONS => {
			"=" => 105
		}
	},
	{#State 82
		ACTIONS => {
			"=" => 106
		}
	},
	{#State 83
		ACTIONS => {
			'IDENT' => 107,
			"]" => 108
		}
	},
	{#State 84
		DEFAULT => -12
	},
	{#State 85
		ACTIONS => {
			"[" => 83,
			'IDENT' => 78
		},
		GOTOS => {
			'node' => 109
		}
	},
	{#State 86
		DEFAULT => -11
	},
	{#State 87
		ACTIONS => {
			"bot" => 72,
			"top" => 82,
			"id" => 81
		},
		GOTOS => {
			'equation_list' => 112,
			'e_info' => 110,
			'equation' => 111
		}
	},
	{#State 88
		DEFAULT => -58
	},
	{#State 89
		DEFAULT => -61
	},
	{#State 90
		ACTIONS => {
			'IDENT' => 114
		},
		GOTOS => {
			'name_list' => 113
		}
	},
	{#State 91
		ACTIONS => {
			'IDENT' => 117
		},
		GOTOS => {
			'coanchor' => 115,
			'coanchor_list' => 116
		}
	},
	{#State 92
		DEFAULT => -57
	},
	{#State 93
		DEFAULT => -33
	},
	{#State 94
		ACTIONS => {
			"}" => 118
		}
	},
	{#State 95
		ACTIONS => {
			"=>" => 119
		}
	},
	{#State 96
		DEFAULT => -37
	},
	{#State 97
		ACTIONS => {
			"," => 120
		},
		DEFAULT => -36
	},
	{#State 98
		ACTIONS => {
			'VAR' => 56,
			'IDENT' => 57
		},
		GOTOS => {
			'f_arg' => 121,
			'fstruct' => 59
		}
	},
	{#State 99
		DEFAULT => -17
	},
	{#State 100
		ACTIONS => {
			"bot" => 72,
			"top" => 82,
			"id" => 81
		},
		GOTOS => {
			'e_info' => 122
		}
	},
	{#State 101
		ACTIONS => {
			"-" => 73,
			"*" => 80,
			"+" => 77,
			"[" => 83,
			'IDENT' => 78,
			"<>" => 85
		},
		GOTOS => {
			'mark_node' => 123,
			'node' => 79
		}
	},
	{#State 102
		DEFAULT => -16
	},
	{#State 103
		ACTIONS => {
			"-" => 73,
			"bot" => 72,
			"+" => 77,
			'IDENT' => 78,
			"*" => 80,
			"id" => 81,
			"top" => 82,
			"[" => 83,
			"<>" => 85
		},
		GOTOS => {
			'info' => 75,
			'mark_node' => 74,
			'e_info' => 76,
			'node_args' => 125,
			'info_node' => 124,
			'node' => 79
		}
	},
	{#State 104
		DEFAULT => -18
	},
	{#State 105
		ACTIONS => {
			'IDENT' => 126
		}
	},
	{#State 106
		ACTIONS => {
			'VAR' => 56,
			'IDENT' => 57
		},
		GOTOS => {
			'f_arg' => 127,
			'fstruct' => 59
		}
	},
	{#State 107
		ACTIONS => {
			"]" => 128
		}
	},
	{#State 108
		DEFAULT => -22
	},
	{#State 109
		DEFAULT => -15
	},
	{#State 110
		ACTIONS => {
			"at" => 129
		}
	},
	{#State 111
		DEFAULT => -72
	},
	{#State 112
		ACTIONS => {
			"," => 130,
			"]" => 131
		}
	},
	{#State 113
		ACTIONS => {
			"," => 132,
			"]" => 133
		}
	},
	{#State 114
		DEFAULT => -63
	},
	{#State 115
		DEFAULT => -65
	},
	{#State 116
		ACTIONS => {
			"," => 134,
			"]" => 135
		}
	},
	{#State 117
		ACTIONS => {
			"=" => 136
		}
	},
	{#State 118
		DEFAULT => -34
	},
	{#State 119
		ACTIONS => {
			'NUM' => 139,
			"(" => 140,
			'VAR' => 141,
			'IDENT' => 137
		},
		GOTOS => {
			'finite' => 142,
			'val' => 138
		}
	},
	{#State 120
		ACTIONS => {
			'IDENT' => 95
		},
		GOTOS => {
			'fval' => 143
		}
	},
	{#State 121
		DEFAULT => -28
	},
	{#State 122
		DEFAULT => -27
	},
	{#State 123
		DEFAULT => -13
	},
	{#State 124
		DEFAULT => -24
	},
	{#State 125
		ACTIONS => {
			"," => 144,
			")" => 145
		}
	},
	{#State 126
		DEFAULT => -30
	},
	{#State 127
		DEFAULT => -29
	},
	{#State 128
		DEFAULT => -23
	},
	{#State 129
		ACTIONS => {
			'IDENT' => 146
		}
	},
	{#State 130
		ACTIONS => {
			"bot" => 72,
			"top" => 82,
			"id" => 81
		},
		GOTOS => {
			'e_info' => 110,
			'equation' => 147
		}
	},
	{#State 131
		DEFAULT => -60
	},
	{#State 132
		ACTIONS => {
			'IDENT' => 148
		}
	},
	{#State 133
		DEFAULT => -62
	},
	{#State 134
		ACTIONS => {
			'IDENT' => 117
		},
		GOTOS => {
			'coanchor' => 149
		}
	},
	{#State 135
		DEFAULT => -59
	},
	{#State 136
		ACTIONS => {
			"(" => 152,
			'IDENT' => 151
		},
		GOTOS => {
			'coanchor_value' => 150
		}
	},
	{#State 137
		ACTIONS => {
			"{" => 153
		},
		DEFAULT => -41
	},
	{#State 138
		DEFAULT => -39
	},
	{#State 139
		DEFAULT => -42
	},
	{#State 140
		ACTIONS => {
			"-" => 154,
			"+" => 155
		},
		GOTOS => {
			'prefix' => 156
		}
	},
	{#State 141
		DEFAULT => -40
	},
	{#State 142
		DEFAULT => -43
	},
	{#State 143
		DEFAULT => -38
	},
	{#State 144
		ACTIONS => {
			"-" => 73,
			"bot" => 72,
			"+" => 77,
			'IDENT' => 78,
			"*" => 80,
			"id" => 81,
			"top" => 82,
			"[" => 83,
			"<>" => 85
		},
		GOTOS => {
			'info' => 75,
			'mark_node' => 74,
			'e_info' => 76,
			'info_node' => 157,
			'node' => 79
		}
	},
	{#State 145
		DEFAULT => -21
	},
	{#State 146
		DEFAULT => -74
	},
	{#State 147
		DEFAULT => -73
	},
	{#State 148
		DEFAULT => -64
	},
	{#State 149
		DEFAULT => -66
	},
	{#State 150
		DEFAULT => -67
	},
	{#State 151
		DEFAULT => -68
	},
	{#State 152
		ACTIONS => {
			'IDENT' => 158
		},
		GOTOS => {
			'coanchor_disj' => 159
		}
	},
	{#State 153
		ACTIONS => {
			'IDENT' => 160
		},
		GOTOS => {
			'finite_args' => 161
		}
	},
	{#State 154
		DEFAULT => -46
	},
	{#State 155
		DEFAULT => -45
	},
	{#State 156
		ACTIONS => {
			")" => 162
		}
	},
	{#State 157
		DEFAULT => -25
	},
	{#State 158
		DEFAULT => -70
	},
	{#State 159
		ACTIONS => {
			";" => 163,
			")" => 164
		}
	},
	{#State 160
		DEFAULT => -48
	},
	{#State 161
		ACTIONS => {
			"}" => 165,
			"," => 166
		}
	},
	{#State 162
		DEFAULT => -44
	},
	{#State 163
		ACTIONS => {
			'IDENT' => 167
		}
	},
	{#State 164
		DEFAULT => -69
	},
	{#State 165
		DEFAULT => -47
	},
	{#State 166
		ACTIONS => {
			'IDENT' => 168
		}
	},
	{#State 167
		DEFAULT => -71
	},
	{#State 168
		DEFAULT => -49
	}
],
                                  yyrules  =>
[
	[#Rule 0
		 '$start', 2, undef
	],
	[#Rule 1
		 'doc', 1,
sub
#line 3 "lib/TAG/LP/Parser.yp"
{}
	],
	[#Rule 2
		 'input', 0, undef
	],
	[#Rule 3
		 'input', 2,
sub
#line 7 "lib/TAG/LP/Parser.yp"
{}
	],
	[#Rule 4
		 'clause', 2, undef
	],
	[#Rule 5
		 'clause', 2, undef
	],
	[#Rule 6
		 'clause', 2, undef
	],
	[#Rule 7
		 'tree', 8,
sub
#line 17 "lib/TAG/LP/Parser.yp"
{ $_[7]->{'name'}=$_[3];
							TAG::LP::Parser::add_tree($_[0],$_[7],$_[5]) }
	],
	[#Rule 8
		 'f_name', 3,
sub
#line 21 "lib/TAG/LP/Parser.yp"
{ $_[3] }
	],
	[#Rule 9
		 'f_family', 3,
sub
#line 24 "lib/TAG/LP/Parser.yp"
{ $_[3] }
	],
	[#Rule 10
		 'f_tree', 3,
sub
#line 27 "lib/TAG/LP/Parser.yp"
{ $_[3] }
	],
	[#Rule 11
		 'v_tree', 2,
sub
#line 30 "lib/TAG/LP/Parser.yp"
{ TAG::Tree->new( root=>$_[2], type=>'initial', families=>[]) }
	],
	[#Rule 12
		 'v_tree', 2,
sub
#line 31 "lib/TAG/LP/Parser.yp"
{ TAG::Tree->new( root=>$_[2], type=>'auxiliary', families=>[]) }
	],
	[#Rule 13
		 'info_node', 3,
sub
#line 34 "lib/TAG/LP/Parser.yp"
{ TAG::LP::Parser::build_node($_[0],$_[3],{ @{$_[1]} }) }
	],
	[#Rule 14
		 'info_node', 1,
sub
#line 35 "lib/TAG/LP/Parser.yp"
{ TAG::LP::Parser::build_node($_[0],$_[1],{}) }
	],
	[#Rule 15
		 'mark_node', 2,
sub
#line 38 "lib/TAG/LP/Parser.yp"
{ $_[2]->{type}='anchor'; $_[2] }
	],
	[#Rule 16
		 'mark_node', 2,
sub
#line 39 "lib/TAG/LP/Parser.yp"
{ $_[2]->{adj}='yes'; $_[2] }
	],
	[#Rule 17
		 'mark_node', 2,
sub
#line 40 "lib/TAG/LP/Parser.yp"
{ $_[2]->{adj}='no'; $_[2] }
	],
	[#Rule 18
		 'mark_node', 2,
sub
#line 41 "lib/TAG/LP/Parser.yp"
{ $_[2]->{type}='foot'; $_[2] }
	],
	[#Rule 19
		 'mark_node', 1, undef
	],
	[#Rule 20
		 'node', 1,
sub
#line 45 "lib/TAG/LP/Parser.yp"
{ TAG::Node->new( { cat=>$_[1], child=>[] } ) }
	],
	[#Rule 21
		 'node', 4,
sub
#line 46 "lib/TAG/LP/Parser.yp"
{ TAG::Node->new( { cat=>$_[1], 
						     type=>'std',
						     child=>$_[3] } ) }
	],
	[#Rule 22
		 'node', 2,
sub
#line 49 "lib/TAG/LP/Parser.yp"
{ TAG::Node->new( { lex=> '', 
						     type=>'lex',
						     child=>[] } 
						   )}
	],
	[#Rule 23
		 'node', 3,
sub
#line 53 "lib/TAG/LP/Parser.yp"
{ TAG::Node->new( { lex=> $_[2], 
						     type=>'lex',
						     child=>[]} ) }
	],
	[#Rule 24
		 'node_args', 1,
sub
#line 58 "lib/TAG/LP/Parser.yp"
{ [ $_[1] ] }
	],
	[#Rule 25
		 'node_args', 3,
sub
#line 59 "lib/TAG/LP/Parser.yp"
{ push(@{$_[1]},$_[3]); $_[1] }
	],
	[#Rule 26
		 'info', 1, undef
	],
	[#Rule 27
		 'info', 3,
sub
#line 63 "lib/TAG/LP/Parser.yp"
{ push(@{$_[1]},@{$_[3]}); $_[1] }
	],
	[#Rule 28
		 'e_info', 3,
sub
#line 66 "lib/TAG/LP/Parser.yp"
{ [ 'bot' => $_[3] ] }
	],
	[#Rule 29
		 'e_info', 3,
sub
#line 67 "lib/TAG/LP/Parser.yp"
{ [ 'top' => $_[3] ] }
	],
	[#Rule 30
		 'e_info', 3,
sub
#line 68 "lib/TAG/LP/Parser.yp"
{ [ 'id' => $_[3] ] }
	],
	[#Rule 31
		 'f_arg', 1,
sub
#line 71 "lib/TAG/LP/Parser.yp"
{ TAG::LP::Parser::checkvar($_[0],$_[1]) }
	],
	[#Rule 32
		 'f_arg', 1, undef
	],
	[#Rule 33
		 'f_arg', 3,
sub
#line 73 "lib/TAG/LP/Parser.yp"
{ TAG::LP::Parser::setvar($_[0],$_[1],$_[3])}
	],
	[#Rule 34
		 'fstruct', 4,
sub
#line 76 "lib/TAG/LP/Parser.yp"
{ TAG::Feature->new( {'f' => { @{$_[3]} }} ) }
	],
	[#Rule 35
		 'fvals', 0, undef
	],
	[#Rule 36
		 'fvals', 1, undef
	],
	[#Rule 37
		 'nfvals', 1,
sub
#line 83 "lib/TAG/LP/Parser.yp"
{ $_[1] }
	],
	[#Rule 38
		 'nfvals', 3,
sub
#line 84 "lib/TAG/LP/Parser.yp"
{ push(@{$_[1]},@{$_[3]}); $_[1] }
	],
	[#Rule 39
		 'fval', 3,
sub
#line 87 "lib/TAG/LP/Parser.yp"
{ TAG::LP::Parser::build_comp($_[0],$_[1],$_[3]) }
	],
	[#Rule 40
		 'val', 1,
sub
#line 90 "lib/TAG/LP/Parser.yp"
{ [ TAG::Link->new({id=>$_[1]}) ] }
	],
	[#Rule 41
		 'val', 1,
sub
#line 91 "lib/TAG/LP/Parser.yp"
{ [ TAG::Val->new({text=>$_[1]})] }
	],
	[#Rule 42
		 'val', 1,
sub
#line 92 "lib/TAG/LP/Parser.yp"
{ [ TAG::Val->new({text=>$_[1]})] }
	],
	[#Rule 43
		 'val', 1, undef
	],
	[#Rule 44
		 'val', 3,
sub
#line 94 "lib/TAG/LP/Parser.yp"
{ $_[2] }
	],
	[#Rule 45
		 'prefix', 1,
sub
#line 97 "lib/TAG/LP/Parser.yp"
{ [ TAG::Plus->new()] }
	],
	[#Rule 46
		 'prefix', 1,
sub
#line 98 "lib/TAG/LP/Parser.yp"
{ [ TAG::Minus->new()] }
	],
	[#Rule 47
		 'finite', 4,
sub
#line 101 "lib/TAG/LP/Parser.yp"
{ $_[3] }
	],
	[#Rule 48
		 'finite_args', 1,
sub
#line 104 "lib/TAG/LP/Parser.yp"
{ [ TAG::Val->new( {text=>$_[1]} ) ] }
	],
	[#Rule 49
		 'finite_args', 3,
sub
#line 105 "lib/TAG/LP/Parser.yp"
{ push(@{$_[1]},TAG::Val->new({text=>$_[3]})); $_[1] }
	],
	[#Rule 50
		 'lemma', 8,
sub
#line 112 "lib/TAG/LP/Parser.yp"
{ TAG::LP::Parser::add_lemma($_[0],$_[3],$_[5],$_[7]) }
	],
	[#Rule 51
		 'anchors', 1, undef
	],
	[#Rule 52
		 'anchors', 3,
sub
#line 116 "lib/TAG/LP/Parser.yp"
{ $_[2] }
	],
	[#Rule 53
		 'anchor_list', 1, undef
	],
	[#Rule 54
		 'anchor_list', 3,
sub
#line 120 "lib/TAG/LP/Parser.yp"
{ push(@{$_[1]},@{$_[3]}); $_[1] }
	],
	[#Rule 55
		 'anchor', 4,
sub
#line 123 "lib/TAG/LP/Parser.yp"
{ [ TAG::Anchor->new( { @{$_[3]} } ) ] }
	],
	[#Rule 56
		 'anchor_features', 1, undef
	],
	[#Rule 57
		 'anchor_features', 3,
sub
#line 127 "lib/TAG/LP/Parser.yp"
{ push(@{$_[1]},@{$_[3]}); $_[1] }
	],
	[#Rule 58
		 'anchor_feature', 3,
sub
#line 130 "lib/TAG/LP/Parser.yp"
{ ['family'=> $_[3]] }
	],
	[#Rule 59
		 'anchor_feature', 5,
sub
#line 131 "lib/TAG/LP/Parser.yp"
{ ['coanchors'=> $_[4]] }
	],
	[#Rule 60
		 'anchor_feature', 5,
sub
#line 132 "lib/TAG/LP/Parser.yp"
{ ['equations'=> $_[4]] }
	],
	[#Rule 61
		 'names', 1,
sub
#line 135 "lib/TAG/LP/Parser.yp"
{ [ $_[1] ] }
	],
	[#Rule 62
		 'names', 3,
sub
#line 136 "lib/TAG/LP/Parser.yp"
{ $_[2] }
	],
	[#Rule 63
		 'name_list', 1,
sub
#line 139 "lib/TAG/LP/Parser.yp"
{ [ $_[1] ] }
	],
	[#Rule 64
		 'name_list', 3,
sub
#line 140 "lib/TAG/LP/Parser.yp"
{ push(@{$_[1]},$_[3]); $_[1] }
	],
	[#Rule 65
		 'coanchor_list', 1,
sub
#line 143 "lib/TAG/LP/Parser.yp"
{ [ $_[1] ] }
	],
	[#Rule 66
		 'coanchor_list', 3,
sub
#line 144 "lib/TAG/LP/Parser.yp"
{ push(@{$_[1]},$_[3]); $_[1] }
	],
	[#Rule 67
		 'coanchor', 3,
sub
#line 147 "lib/TAG/LP/Parser.yp"
{ TAG::Coanchor->new({node_id=>$_[1],lex=>$_[3]}) }
	],
	[#Rule 68
		 'coanchor_value', 1,
sub
#line 150 "lib/TAG/LP/Parser.yp"
{ [ TAG::Lex->new({text=>$_[1]}) ] }
	],
	[#Rule 69
		 'coanchor_value', 3,
sub
#line 151 "lib/TAG/LP/Parser.yp"
{ $_[2] }
	],
	[#Rule 70
		 'coanchor_disj', 1,
sub
#line 154 "lib/TAG/LP/Parser.yp"
{ [ TAG::Lex->new({text=>$_[1]}) ] }
	],
	[#Rule 71
		 'coanchor_disj', 3,
sub
#line 155 "lib/TAG/LP/Parser.yp"
{ push(@{$_[1]},TAG::Lex->new({text=>$_[3]})); $_[1] }
	],
	[#Rule 72
		 'equation_list', 1,
sub
#line 158 "lib/TAG/LP/Parser.yp"
{ $_[1] }
	],
	[#Rule 73
		 'equation_list', 3,
sub
#line 159 "lib/TAG/LP/Parser.yp"
{ push(@{$_[1]},@{$_[3]}); $_[1] }
	],
	[#Rule 74
		 'equation', 3,
sub
#line 162 "lib/TAG/LP/Parser.yp"
{ TAG::LP::Parser::build_equations($_[0],$_[3],{@{$_[1]}}) }
	],
	[#Rule 75
		 'lexical', 10,
sub
#line 170 "lib/TAG/LP/Parser.yp"
{ TAG::LP::Parser::add_lexical($_[0],$_[3],$_[5],$_[7],$_[9]) }
	]
],
                                  @_);
    bless($self,$class);
}

#line 173 "lib/TAG/LP/Parser.yp"


package TAG::LP::Parser;

my %bind;

sub add_lexical {
    my ($parser,$name,$lemma,$cat,$equation) = @_;
    my $lexicon = TAG::Lexicon->new( {lex=>$name,
				      lemma=> [ TAG::LemmaRef->new( { name=>$lemma,
								      cat=>$cat,
								      feature=>$equation })
					       ]});
    $parser->YYData->{TAG}{'lexicon'}{$name} = $lexicon;
}


sub add_lemma {
    my ($parser,$name,$cat,$anchors) = @_;
    my $lemma = TAG::Lemma->new( { name=>$name,
				   cat=>$cat,
				   anchors=>$anchors });
    $parser->YYData->{TAG}{'lemma'}{$name}{$cat}=$lemma;
}

sub add_tree {
    my ($parser,$tree,$family) = @_;
    push(@{$tree->{'families'}},$family);
    my $fentry =  $parser->YYData->{TAG}{families}{$family};
    if (!$fentry) {
	$fentry = TAG::Family->new({name=>$family,trees=>[]});
	$parser->YYData->{TAG}{families}{$family}=$fentry;
    }
    push(@{$fentry->{'trees'}},$tree->{name});
    $parser->YYData->{TAG}{trees}{$tree->{name}}=$tree;
}

sub build_node {
    my ($parser,$node,$args) = @_;
    my $id = $args->{'id'};
    my $top = $args->{'top'};
    my $bot = $args->{'bot'};
    $node->{'type'}='subst' unless ($node->{type});
    $node->{'id'}=$id if ($id);
    $node->{'top'}=$top if ($top);
    $node->{'bot'}=$bot if ($bot);
    return $node;
}

sub build_equations {
    my ($parser,$node_id,$args) = @_;
    my @equations = ();
    if (defined $args->{'top'}) {
	push(@equations,TAG::Equation->new( node_id => $node_id, type => 'top', feature => $args->{'top'} ));
    }
    if (defined $args->{'bot'}) {
	push(@equations,TAG::Equation->new( node_id => $node_id, type => 'bot', feature => $args->{'bot'} ));
    }
    return [ @equations ];
}

sub build_comp {
    my ($parser,$name,$val) = @_;
    my $comp = TAG::Comp->new( 'name' => $name, 'value'=>[]);
    foreach my $v (@{$val}) {
	$comp->{'id'} = $v->{'id'}, next if ($v->isa('TAG::Link'));
	push @{ $comp->{'value'} },$v;
    }
    return [ $name => $comp ];
}

sub _Error {
        exists $_[0]->YYData->{ERRMSG}
    and do {
        print $_[0]->YYData->{ERRMSG};
        delete $_[0]->YYData->{ERRMSG};
        return;
    };
    print "Syntax error.\n";
}

sub setvar {
    my ($parser,$var,$val) = @_;
    $parser->YYData->{VARS}{$var}=$val;
    return $val;
}

sub checkvar {
    my ($parser,$var) = @_;
    if (defined $parser->YYData->{VARS}{$var}) { 
	return $parser->YYData->{VARS}{$var};
    } else {
	return ;
    }
}

sub _Lexer {
    my($parser)=shift;

toto:

        $parser->YYData->{INPUT}
    or  $parser->YYData->{INPUT} = <>
    or  return('',undef);

#    print STDERR "INPUT: ",$parser->YYData->{INPUT},"\n";

    goto toto if ($parser->YYData->{INPUT}=~s/^\s+//s);
    goto toto if ($parser->YYData->{INPUT}=~s/^%[^\n]*[\n\r]*//m);
    goto toto if ($parser->YYData->{INPUT}=~s/^:-[^\n]*[\n\r]*//m);

    goto toto if ($parser->YYData->{INPUT}=~s%^/\*.*?\*/%%ms);

#    print STDERR "INPUT2: ",$parser->YYData->{INPUT},"\n";
#    goto toto if ($parser->YYData->{INPUT} =~ m/^\s*$/ );

    for ($parser->YYData->{INPUT}) {
        s/^((?:=>|::|tree|auxtree|and|at|tag_tree|tag_lexicon|tag_lemma|tag_anchor|name|family|id|top|bot|equations|coanchors))//o
                and return($1,$1);
        s/^((?:[+*-]|<>))//s
                and return($1,$1);
        s/^(\d+(?:\.\d+)?)//
                and return('NUM',$1);
        s/^([a-z][a-zA-Z0-9_]*)//
                and return('IDENT',$1);
        if (s/^'((?:[^']|'')*)'//s) {
           my $s = $1;
           $s =~ s/\'\'/\'/og;
           return('IDENT',$s);
        }
        s/^([A-Z_][A-Za-z0-9_]*)//
                and return('VAR',$1);
        s/^(.)//s
                and return($1,$1);
    }

}

1;

__END__

=head1 NAME

TAG::LP::Parser - Parse a TAG grammar in LP format

=head1 SYNOPSIS

 use TAG::LP::Parser;
 use TAG;

 $doc = new TAG::Document;
 $parser = new TAG::LP::Parser;
 $/="";
 $parser->YYData->{TAG} = $doc; 
 $parser->YYParse( yylex => \&TAG::LP::Parser::_Lexer, 
                   yyerror => \&TAG::LP::Parser::_Error );


=head1 DESCRIPTION

This module provides ways to parse Tree Adjoining Grammars that are in
Logic Programming [LP] format, and to build a TAG::Document object to
represent the grammar.

=head1 COPYRIGHT AND LICENSE

Copyright (C) 2000-2007, INRIA.

This program is free software; you can redistribute it and/or modify it under
the same terms as Perl itself.

=head1 AUTHOR

Eric de la Clergerie <Eric.De_La_Clergerie@inria.fr>

=head1 SEE ALSO

TAG (3)

=cut

1;
